<template>
  <node-view-wrapper as="div" class="group relative mx-auto flex w-full gap-2">
    <div class="relative mx-auto w-full max-w-[1044px]">
      <div
        v-if="editor.isEditable"
        class="absolute -left-[65px] -top-0.5 transition-opacity hidden group-hover:flex group-focus-within:flex group-focus:flex items-center"
        :class="dialog ? 'opacity-100' : ''"
      >
        <svn-pro-icon-button
          icon="custom:mingcute:add-line"
          variant="text"
          color="onSurfaceVariant"
          :density="'comfortable'"
          @click="openAddMenu"
        />

        <v-dialog
          v-model="dialog"
          :scrim="false"
          :absolute="true"
          :close-on-content-click="true"
          :contained="true"
          content-class="top-2"
        >
          <template #activator="{ props }">
            <svn-pro-icon-button
              @click="dialog = !dialog"
              draggable="true"
              data-drag-handle
              icon="custom:mingcute:dots-fill"
              variant="text"
              color="onSurfaceVariant"
              :density="'comfortable'"
            />
          </template>

          <template #default>
            <div class="w-[220px] max-h-[496px] rounded-[4px] py-2 h-full flex flex-col bg-surface cardShadow">
              <v-list
                color="primary"
                density="compact"
                class="!py-0 w-full"
              >
                <v-list-item
                  v-for="(item, index) in items"
                  :key="item.value"
                  :active="false"
                  :value="item.value"
                  @click="item?.onClick()"
                >
                  <div class="w-full flex gap-3 whitespace-nowrap">
                    <div>
                      <Icon
                        :icon="item?.icon"
                        height="24"
                        width="24"
                        :class="item?.iconClass"
                      />
                    </div>

                    <svn-pro-text
                      regular
                      bodyLarge
                      class="truncate text-ellipsis"
                      :color="index === items?.length - 1 ? 'error' : 'onSurface'"
                    >
                      {{ item.title }}
                    </svn-pro-text>
                  </div>
                </v-list-item>
              </v-list>
            </div>
          </template>
        </v-dialog>
      </div>

      <node-view-content class="w-full content rounded wrapper overflow-x-auto overflow-y-hidden" />
    </div>
  </node-view-wrapper>
</template>

<script setup>
import { ref } from 'vue';
import { Icon } from '@iconify/vue';
import SvnProText from '../../styles/SvnProText.vue';
import SvnProIconButton from '../../button/SvnProIconButton.vue';
import useContentItemMenuActions from '../hooks/useContentItemMenuActions.js';
import { NodeViewContent, nodeViewProps, NodeViewWrapper } from '@tiptap/vue-3';

const props = defineProps(nodeViewProps);

const dialog = ref(false);

const openAddMenu = () => {
  const node = props.node;
  const nodePos = props.getPos() + props.node.nodeSize;
  useContentItemMenuActions(props.editor, node, nodePos).handleAdd()
}

const clearBlockFormatting = () => {
  const node = props.node;
  const nodePos = props.getPos();
  useContentItemMenuActions(props.editor, node, nodePos).resetTextFormatting()
}

const copyBlockToClipboard = () => {
  const node = props.node;
  const nodePos = props.getPos();
  useContentItemMenuActions(props.editor, node, nodePos).copyNodeToClipboard()
}

const duplicateBlock = () => {
  const node = props.node;
  const nodePos = props.getPos();
  useContentItemMenuActions(props.editor, node, nodePos).duplicateNode()
}

const deleteBlock = () => {
  const node = props.node;
  const nodePos = props.getPos();
  useContentItemMenuActions(props.editor, node, nodePos).deleteNode()
}

const items = [
  {
    value: "clear_formatting",
    title: "Clear formatting",
    icon: "mingcute:refresh-3-line",
    iconClass: "text-onSurfaceVariant",
    onClick: () => clearBlockFormatting()
  },
  {
    value: "copy_to_clipboard",
    title: "Copy to clipboard",
    icon: "mingcute:clipboard-line",
    iconClass: "text-onSurfaceVariant",
    onClick: () => copyBlockToClipboard()
  },
  {
    value: "duplicate_block",
    title: "Duplicate",
    icon: "mingcute:copy-2-line",
    iconClass: "text-onSurfaceVariant",
    onClick: () => duplicateBlock()
  },
  {
    value: "delete_block",
    title: "Delete",
    icon: "mingcute:delete-2-line",
    iconClass: "text-error",
    onClick: () => deleteBlock()
  },
]
</script>

<style lang="scss">
.content {
  flex: 1 1 auto;
}

.wrapper:hover {
  background-color: rgb(var(--v-theme-veryLightGrey));
}

.wrapper:not(.img-uploader):hover {
  background-color: transparent !important;
}
</style>

<style scoped>
.cardShadow {
  box-shadow: 0px 2px 2px 0px rgba(0, 0, 0, 0.14), 0px 3px 1px 0px rgba(0, 0, 0, 0.12), 0px 1px 5px 0px rgba(0, 0, 0, 0.20);
}
</style>